/*

written by xoclipse
http://xoclipse.fraghosts.net

gsmsalg(gamespy challenge algorithm) 
GSMSALG 0.1.1
by Luigi Auriemma


*/

#include <stdio.h>
#include "gsmsalg.h"

//#define win32

#ifdef win32

    #include <windows.h>
    #pragma comment(lib, "ws2_32.lib")
    #define close closesocket

#else

    #include <unistd.h>
    #include <sys/socket.h>
    #include <sys/types.h>
    #include <arpa/inet.h>
    #include <netdb.h>

#endif

#define GAMESPY "master.gamespy.com"
#define BUFSIZE 1460
#define handoff "M5Fdwc"

int main(int argc, char *argv[])
{
	int sockfd, ret;
	struct  hostent *host;
	struct sockaddr_in remote;
	char *packet = (char*)malloc(10000000);
	int pos;
	char *buf = (char*)malloc(BUFSIZE);
#ifdef win32
	WSAData wsad;
	WSAStartup(MAKEWORD(1,1), &wsad);
#endif

	sockfd = socket(AF_INET, SOCK_STREAM, IPPROTO_IP);

	host = gethostbyname(GAMESPY);

	remote.sin_family = AF_INET;
	remote.sin_port = htons(28900);
	remote.sin_addr.s_addr =  *(unsigned long *)(host->h_addr);

	connect(sockfd, (struct sockaddr*)&remote, sizeof(remote));

	ret = recv(sockfd, buf, BUFSIZE, 0);
	buf++;
	for(;*buf!=0x5C;buf++);
	buf++;
	for(;*buf!=0x5C;buf++);
	buf++;
	for(;*buf!=0x5C;buf++);
	buf++;
	unsigned char *response = gsseckey((unsigned char*)buf, (unsigned char*)handoff, 0);
	char query[512];
	int len;
	len = sprintf(query, "\\basic\\gamename\\mohaa\\location\\0\\validate\\%s\\final\\list\\\\gamename\\mohaa\\final\\", response);
	send(sockfd, query, len, 0);
	pos = 0;
	while(ret>0)
	{
		ret = recv(sockfd, buf, BUFSIZE, 0);
		if(ret > 0)
		{
			memcpy(packet+pos, buf, ret);
			pos += ret;
		}
	}
	packet[pos] = 0;
	printf("%s", packet);
	
	return 0;
}
